Require Import connectives.
Require Import leibniz.
Parameter bool : Type.
Parameter true : bool.
Parameter false : bool.
Parameter match_bool_type : forall (return_:Type), return_ -> return_ -> bool -> return_.
Axiom axiom_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), connectives.equal (return_) (match_bool_type (return_) case_true case_false true) case_true.
Definition eq_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) (match_bool_type (return_) case_true case_false true) case_true := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((connectives.equal_leibniz) (return_)) (match_bool_type (return_) case_true case_false true)) (case_true)) ((((axiom_match_bool_type_true) (return_)) (case_true)) (case_false)).
Axiom axiom_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), connectives.equal (return_) (match_bool_type (return_) case_true case_false false) case_false.
Definition eq_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) (match_bool_type (return_) case_true case_false false) case_false := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((connectives.equal_leibniz) (return_)) (match_bool_type (return_) case_true case_false false)) (case_false)) ((((axiom_match_bool_type_false) (return_)) (case_true)) (case_false)).
Definition sym_eq_match_bool_type_true : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) case_true (match_bool_type (return_) case_true case_false true) := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((leibniz.sym_leibniz) (return_)) (match_bool_type (return_) case_true case_false true)) (case_true)) ((((eq_match_bool_type_true) (return_)) (case_true)) (case_false)).
Definition sym_eq_match_bool_type_false : forall return_, forall (case_true:return_), forall (case_false:return_), leibniz.leibniz (return_) case_false (match_bool_type (return_) case_true case_false false) := fun (return_:Type) => fun (case_true:return_) => fun (case_false:return_) => ((((leibniz.sym_leibniz) (return_)) (match_bool_type (return_) case_true case_false false)) (case_false)) ((((eq_match_bool_type_false) (return_)) (case_true)) (case_false)).
