Require Import div_mod.
Require Import logic.
Require Import nat.
Definition congruent : nat.nat -> nat.nat -> nat.nat -> Prop := fun (n:nat.nat) => fun (m:nat.nat) => fun (p:nat.nat) => logic.eq (nat.nat) (div_mod.mod n p) (div_mod.mod m p).
Definition mod_mod : forall (n:nat.nat), forall (p:nat.nat), (nat.lt nat.O p) -> logic.eq (nat.nat) (div_mod.mod n p) (div_mod.mod (div_mod.mod n p) p) := fun (n:nat.nat) => fun (p:nat.nat) => fun (posp:nat.lt nat.O p) => (((((((logic.eq_ind_r) (nat.nat)) (nat.plus (nat.times (div_mod.div (div_mod.mod n p) p) p) (div_mod.mod (div_mod.mod n p) p))) (fun (x:nat.nat) => logic.eq (nat.nat) x (div_mod.mod (div_mod.mod n p) p))) (((((((logic.eq_ind_r) (nat.nat)) (nat.O)) (fun (x:nat.nat) => logic.eq (nat.nat) (nat.plus (nat.times x p) (div_mod.mod (div_mod.mod n p) p)) (div_mod.mod (div_mod.mod n p) p))) (((((((logic.rewrite_r) (nat.nat)) (nat.times p nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.plus __ (div_mod.mod (div_mod.mod n p) p)) (div_mod.mod (div_mod.mod n p) p))) (((((((logic.rewrite_l) (nat.nat)) (nat.O)) (fun (__:nat.nat) => logic.eq (nat.nat) (nat.plus __ (div_mod.mod (div_mod.mod n p) p)) (div_mod.mod (div_mod.mod n p) p))) (((((((logic.rewrite_l) (nat.nat)) (div_mod.mod (div_mod.mod n p) p)) (fun (__:nat.nat) => logic.eq (nat.nat) __ (div_mod.mod (div_mod.mod n p) p))) (((logic.refl) (nat.nat)) (div_mod.mod (div_mod.mod n p) p))) (nat.plus nat.O (div_mod.mod (div_mod.mod n p) p))) ((nat.plus_O_n) (div_mod.mod (div_mod.mod n p) p)))) (nat.times p nat.O)) ((nat.times_n_O) (p)))) (nat.times nat.O p)) (((nat.commutative_times) (nat.O)) (p)))) (div_mod.div (div_mod.mod n p) p)) ((((div_mod.eq_div_O) (div_mod.mod n p)) (p)) ((((div_mod.lt_mod_m_m) (n)) (p)) (posp))))) (div_mod.mod n p)) (((div_mod.div_mod) (div_mod.mod n p)) (p))).
Definition congruent_n_mod_n : forall (n:nat.nat), forall (p:nat.nat), (nat.lt nat.O p) -> congruent n (div_mod.mod n p) p := fun (n:nat.nat) => fun (p:nat.nat) => fun (posp:nat.lt nat.O p) => ((((mod_mod) (n)) (p)) (posp)).
